<?php 

	/*
Plugin Name: Buzer Gesetze verlinken
Plugin URI: http://www.buzer.de/li.htm
Description: verlinkt im Text zitierte Gesetzesverweise und EU-Normen
Author: www.buzer.de
Version: 1.06
Author URI: http://www.buzer.de/
*/

class clsBuzer {

	var $done = 0;

	var $buzer_config = array (
	
		'version' => '1.06',

		# beliebige Anzahl Attribute zur Linkformatierung des Titels 
		# z.B. 'at'=>'target="_blank"' erzeugt Links wie <a href="ziel" target="_blank">...
		# kann beispielsweise auch fr die Formatierung (style, class, etc.) 
		# oder auch zum Plazieren von Skripten verwendet werden
		'at' 	=> 'target="_blank"',
		
		# analog zu 'at' nur die verlinkten Paragraphen/Artikel betreffend
		'ap'	=> 'target="_blank"',

		#  Zitierrichtung, Standand ist  1 der ZPO, d.h. der Titel wird rechts 
		# vom Paragraphen erwartet, dann ist hier keine Angabe notwendig, 
		# wird z.B. ZPO  1, 2, 3 etc. verwendet, funktioniert das Verlinken 
		# nur wenn das Flag 'lr' gesetz ist, z.B. 'lr' => 1
		'lr'	=> 0,
		
		# falls true, werden nur kurze Verlinkungen erzeugt
		# z.B. im Text " 1 Abs. 2 Satz 3" wird nur die "1" verlinkt
		# wenn false, wrde der gesamte Text verlinkt werden
		'nolong'	=> 0,
		# falls true, werden die Titel selbst nicht verlinkt, also 
		# z.B. bei  1 BGB wird nur der  1 verlinkt, allerdings 
		#erhlt dann natrlich auch "die Vorschriften des BGB bestimmen" keinen Link
		'not'	=> 0,
		
		# kommaseparierte Liste von Titeln, die mit diesem Titel nie verlinkt werden
		# WEG meint hfiger den Weg als das WEG, ALG ist oft ALG II
		'notitle' => 'WEG,ALG,WHG,FANG,AUG,LAG,ARG',
		
		# falls true, werden Sonderzeichen html-codiert
		'esc'	=> 0,
		
		# ersetzt aufeinanderfolgende Leerzeichen durch eines, 
		# fhrt zu besseren Ergebnissen, 
		# falls Text stark durch Verwendung von Leerzeichen formatiert ist, 
		# zerstrt dann allerdings auch diese Formatierung
		'trim'	=> 0,
		
		# Zieladresse fr Postheader
		'_post'		=> '/li.htm',

		# Servername 
		'_host'	=> 'http://www.buzer.de',
		# ODER
		#'_host'	=> 'https://www.buzer.de',
		# Anm. zu SSL - erfordert installiertes und konfiguriertes openssl auf Ihrem Server			
		
		# timeout fr Verbindung zu buzer.de in Sekunden, falls berschritten 
		# wird der Eingangstext zurckgegeben
		'_timeout'	=> 5,
		
		# false hier eine Angabe erfolgt, wird eine Tabelle dieses Namens
		# als Cache verwendet
		# bei Angabe erfolgt die Verlinkung bei Anzeige des Artikels
		# wenn leer, wird der Artikel beim Speichern in der Datenbank verlinkt
		'_cache'	=> 'buzer_cache',
		
		# Debug falls true
		'_debug'	=> 0,
		
	);

	function __construct() {
		return $this;
	}


	function buzer_getCache( $config, $text, $id) {
		# gibt falls vorhandenen den cache zurck
		global $db;
		$result = $db->sql_query( "select cache from ".$config['_cache']." 
			where hash = md5('".$db->sql_escape($text)."') 
			limit 1;");
		$cache = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);
		return $cache['cache'] == "1" ? $text : $cache['cache'];
		
	}
	
	function buzer_insertCache( $config, $text, $cache, $id) {
		# schreibt die verlinkte version in den cache
		global $db;

		$sql = "update ignore ".$config['_cache']."
			set cache=convert('".$db->sql_escape($text." "==$cache?1:$cache)."' using latin1), 				
			dateupdate=now(), 
			hash=md5('".$db->sql_escape($text)."')
			where id=0$id";
		if ( $db->sql_affectedrows($db->sql_query( $sql))) {
			return 1;
		}
		
		$sql = "insert ignore into ".$config['_cache']." (id, cache, hash, dateinsert) 
			values (0$id, convert('".$db->sql_escape($text." "==$cache?1:$cache)."' using latin1), md5('".$db->sql_escape($text)."'), now())";
		return $db->sql_query( $sql );

	}

	function buzer_LinkIt($textin, $charset, $id) {
		# verlinkt den bergebenen text
		global $request;
		
		$buzer_config=$this->buzer_config;
	
		if ( !$textin ) {
			return $textin;
		}
		if ( strlen($charset)>0 ) {
			$buzer_config['charset']=$charset;
		}
		if ( $cache=$this->buzer_getCache( $buzer_config, $textin, $id) ) { return $cache; }	

		if ( $this->done ) {
			return $textin;
		}
		
		# maximal ein request pro Seitenabruf
		$this->done = 1;
		
		$array = array(
				'plugin' => 'phpbb',
				'site' => $request->variable('HTTP_HOST', ''),
			);

		foreach ($buzer_config as $key => $value) {
			if ( $value && !preg_match('/^_/', $key )) {

				$array[$key] = $value;
			}
		}
		
		$array['text'] = $textin;

		$postdata = http_build_query($array);


		$opts = array('http' =>
			array(
				'method'  => 'POST',
				'header'  => 'Content-type: application/x-www-form-urlencoded; charset=' . $buzer_config['charset'],
				'timeout' => $buzer_config['_timeout'],
				'content' => $postdata			
			)
		);

		$reqcontext = stream_context_create($opts);

		$textout = file_get_contents($buzer_config['_host'].$buzer_config['_post'], false, $reqcontext);

		if ( $buzer_config['_debug']) echo "length: ".strlen($textout)."<br />";


		$cmd = substr( $textout, -100);
		$ok  =  ( substr($cmd, 0, 2) == "OK" );
		
		if ( $buzer_config['_debug']) echo "read: ok=$ok, textout=$textout<br />";
		
		if ( !$ok ) {
			return $textin;
		}	
		




		$textout = substr( $textout, 0, -100);	
		

		if ( $textin and strlen($textout)<strlen($textin) ) {
			if ( $buzer_config['_debug']) echo "Break: zu kurz<br />";
			return $textin;
		} 
		
		if ( $buzer_config['_skip'] and preg_match('/'.$buzer_config['_skip'].'/', $textout) ) {
			if ( $buzer_config['_debug']) echo "Break: skip<br />";
			return $textin;
		} 
		
		$this->buzer_insertCache( $buzer_config, $textin, $textout, $id);
		return $textout;

	}
	
}

$gBuzer = new clsBuzer();


?>